internal void Main_Entry_Point (int argc, WCHAR **argv); 

#if OS_WINDOWS
 #if BUILD_CONSOLE_INTERFACE
  int wmain(int argc, WCHAR **argv) {
    Main_Entry_Point(argc, argv);
    return 0;
  }
 #else
  #include <cstdlib> // globals __argc, __wargv
 
  int wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nShowCmd) {
    Main_Entry_Point(__argc, __wargv);
    return 0;
  }
 #endif
#endif

internal void Main_Entry_Point (int argc, WCHAR **argv) { // #entry_point
  set_cpu_base_frequency(3200); // REQUIRED FOR TIMING MODULE! will depend on CPU
  
#if BASE_RUN_TESTS
  run_pre_setup_tests(); // #no_context: context will not be initialized at this point.
#endif
  // #NOTE: Be careful using a timing or auto-release macros 
  // before setting up the thread context!
  Bootstrap_Main_Thread_Context();
  
#if OS_WINDOWS
  Win32_Entry_Point(argc, argv);
#endif
#if OS_LINUX
  // Linux_Entry_Point(argc, argv);
#endif
#if BASE_RUN_TESTS
  run_post_setup_tests();
#endif
#if BUILD_EXPLORER_APP_WIN32 // #entry_point
  Explorer_ImGui_Application_Win32(); // #rename
#endif
#if BUILD_CUSTOM_GUI
 // Custom GUI based on Vik's prototype [WIP]
 /* Alternative if we're using OpenGL.
  graphics_set_render_target(get_main_window());
  
  // 3. Init Graphics (DX11 or OpenGL3)
  // #TODO: #Graphics#Main - `Main_Entry_Point`
  
  // 4. [ ] Setup Mouse and Keyboard Inputs 
  // 5. [ ] Launch second thread; thread groups
 */
#endif
}

